diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/emlsr-manager.h ns-3.44/src/wifi/model/eht/emlsr-manager.h
--- ns-3.43/src/wifi/model/eht/emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/emlsr-manager.h	2025-03-09 16:55:49.787372600 -0700
@@ -550,6 +697,118 @@
         m_mainPhyChannels; //!< link ID-indexed map of operating channels for the main PHY
     std::map<uint8_t, WifiPhyOperatingChannel>
         m_auxPhyChannels; //!< link ID-indexed map of operating channels for the aux PHYs
+    std::map<uint8_t, Time>
+        m_noPhySince; //!< link ID-indexed map of the time since no PHY is operating on the link
+};
+
+/**
+ * Struct to trace that main PHY switched to start a DL TXOP after that an aux PHY received an ICF.
+ */
+struct EmlsrDlTxopIcfReceivedByAuxPhyTrace
+    : public EmlsrMainPhySwitchTraceImpl<EmlsrDlTxopIcfReceivedByAuxPhyTrace>
+{
+    static constexpr std::string_view m_name = "DlTxopIcfReceivedByAuxPhy"; //!< trace name
+};
+
+/**
+ * Struct to trace that main PHY switched to start an UL TXOP after that an aux PHY transmitted an
+ * RTS.
+ */
+struct EmlsrUlTxopRtsSentByAuxPhyTrace
+    : public EmlsrMainPhySwitchTraceImpl<EmlsrUlTxopRtsSentByAuxPhyTrace>
+{
+    static constexpr std::string_view m_name = "UlTxopRtsSentByAuxPhy"; //!< trace name
+};
+
+/**
+ * Struct to trace that main PHY switched when a (DL or UL) TXOP ended.
+ *
+ * This trace is normally called when aux PHYs do not switch link and the main PHY switches back to
+ * the preferred link when a TXOP carried out on another link ends. In such a case, the remTime
+ * field is set to zero.
+ *
+ * Note that the main PHY may be already switching when the TXOP ends; this happens, e.g., when the
+ * main PHY starts switching to a link on which an aux PHY gained a TXOP and sent an RTS, but the
+ * CTS is not received and the UL TXOP ends before the main PHY channel switch is completed. In this
+ * case, the main PHY switch is postponed until the previous switch is completed and the remTime
+ * field is set to the remaining channel switch delay at the time the TXOP ends:
+ *
+ *                                |-- main PHY switch --|
+ *                                |----- to link 1 -----|
+ *                                          ┌───────────┐
+ *                                          │    CTS    │
+ *  ────────────────────────┬───────────┬───┴X──────────┴─────────────────────────────
+ *  [link 1]                │    RTS    │     │-remTime-│
+ *                          └───────────┘     │         |-- main PHY switch --|
+ *                                            │         |- to preferred link -|
+ *                                         CTS timeout
+ *
+ * Note also that the Advanced EMLSR manager may allow a main PHY switch to be interrupted. If this
+ * option is enabled and the main PHY is switching when the TXOP ends, the previous switch is
+ * interrupted and the main PHY starts switching to the preferred link (in this case, the remTime
+ * field indicates the time that was left to complete the previous switch). Also note that, with
+ * the Advanced EMLSR manager, this trace may also be called when aux PHYs switch link. This happens
+ * when the TXOP ends while the main PHY is switching; in this case, the previous switch is
+ * interrupted and the main PHY returns to the link on which it was operating before the previous
+ * switch.
+ *
+ *                                |-- main PHY switch --|
+ *                                |----- to link 1 -----|(interrupted)
+ *                                          ┌───────────┐
+ *                                          │    CTS    │
+ *  ────────────────────────┬───────────┬───┴X──────────┴─────────────────────────────
+ *  [link 1]                │    RTS    │     │-remTime-│
+ *                          └───────────┘     │-- main PHY switch --|
+ *                                            │- to preferred link -|
+ *                                         CTS timeout
+ */
+struct EmlsrTxopEndedTrace : public EmlsrMainPhySwitchTraceImpl<EmlsrTxopEndedTrace>
+{
+    static constexpr std::string_view m_name = "TxopEnded"; //!< trace name
+
+    Time remTime; //!< the remaining time (at TXOP end) until the main PHY completes the
+                  //!< channel switch, in case the main PHY is completing a previous switch
+                  //!< when the TXOP ends
+
+    /**
+     * Constructor provided because this struct is not an aggregate (it has a base struct), hence
+     * we cannot use designated initializers.
+     *
+     * @param t the value for the sinceTxopEnd field
+     */
+    EmlsrTxopEndedTrace(const Time& t)
+        : remTime(t)
+    {
+    }
+};
+
+/**
+ * Struct to trace that main PHY switched to operate on a link on which an aux PHY that is not
+ * TX capable has gained or is expected to shortly gain a TXOP.
+ */
+struct EmlsrUlTxopAuxPhyNotTxCapableTrace
+    : public EmlsrMainPhySwitchTraceImpl<EmlsrUlTxopAuxPhyNotTxCapableTrace>
+{
+    static constexpr std::string_view m_name = "UlTxopAuxPhyNotTxCapable"; //!< trace name
+
+    AcIndex acIndex; //!< Access category of TXOP on aux PHY
+    Time remTime;    //!< Remaining time to complete backoff countdown on the aux PHY link
+    Time remNav;     //!< the remaining NAV on main PHY link when main PHY is requested to switch
+
+    /**
+     * Constructor provided because this struct is not an aggregate (it has a base struct), hence
+     * we cannot use designated initializers.
+     *
+     * @param aci the value for the acIndex field
+     * @param delay the value for the remTime field
+     * @param navLeft the value for the remNav field
+     */
+    EmlsrUlTxopAuxPhyNotTxCapableTrace(AcIndex aci, const Time& delay, const Time& navLeft)
+        : acIndex(aci),
+          remTime(delay),
+          remNav(navLeft)
+    {
+    }
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/eht/multi-link-element.cc ns-3.44/src/wifi/model/eht/multi-link-element.cc
--- ns-3.43/src/wifi/model/eht/multi-link-element.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/eht/multi-link-element.cc	2025-03-09 16:55:49.787372600 -0700
@@ -9,281 +9,16 @@
 #include "multi-link-element.h"
 
 #include "ns3/address-utils.h"
+#include "ns3/log.h"
 #include "ns3/mgt-headers.h"
 
 #include <utility>
 
-namespace ns3
-{
-
-/**
- * CommonInfoBasicMle
- */
-
-uint16_t
-CommonInfoBasicMle::GetPresenceBitmap() const
-{
-    // see Sec. 9.4.2.312.2.1 of 802.11be D1.5
-    return (m_linkIdInfo.has_value() ? 0x0001 : 0x0) |
-           (m_bssParamsChangeCount.has_value() ? 0x0002 : 0x0) |
-           (m_mediumSyncDelayInfo.has_value() ? 0x0004 : 0x0) |
-           (m_emlCapabilities.has_value() ? 0x0008 : 0x0) |
-           (m_mldCapabilities.has_value() ? 0x0010 : 0x0);
-}
-
-uint8_t
-CommonInfoBasicMle::GetSize() const
-{
-    uint8_t ret = 7; // Common Info Length (1) + MLD MAC Address (6)
-    ret += (m_linkIdInfo.has_value() ? 1 : 0);
-    ret += (m_bssParamsChangeCount.has_value() ? 1 : 0);
-    ret += (m_mediumSyncDelayInfo.has_value() ? 2 : 0);
-    ret += (m_emlCapabilities.has_value() ? 2 : 0);
-    ret += (m_mldCapabilities.has_value() ? 2 : 0);
-    return ret;
-}
-
-void
-CommonInfoBasicMle::Serialize(Buffer::Iterator& start) const
-{
-    start.WriteU8(GetSize()); // Common Info Length
-    WriteTo(start, m_mldMacAddress);
-    if (m_linkIdInfo.has_value())
-    {
-        start.WriteU8(*m_linkIdInfo & 0x0f);
-    }
-    if (m_bssParamsChangeCount.has_value())
-    {
-        start.WriteU8(*m_bssParamsChangeCount);
-    }
-    if (m_mediumSyncDelayInfo.has_value())
-    {
-        start.WriteU8(m_mediumSyncDelayInfo->mediumSyncDuration);
-        uint8_t val = m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold |
-                      (m_mediumSyncDelayInfo->mediumSyncMaxNTxops << 4);
-        start.WriteU8(val);
-    }
-    if (m_emlCapabilities.has_value())
-    {
-        uint16_t val =
-            m_emlCapabilities->emlsrSupport | (m_emlCapabilities->emlsrPaddingDelay << 1) |
-            (m_emlCapabilities->emlsrTransitionDelay << 4) |
-            (m_emlCapabilities->emlmrSupport << 7) | (m_emlCapabilities->emlmrDelay << 8) |
-            (m_emlCapabilities->transitionTimeout << 11);
-        start.WriteHtolsbU16(val);
-    }
-    if (m_mldCapabilities.has_value())
-    {
-        uint16_t val =
-            m_mldCapabilities->maxNSimultaneousLinks | (m_mldCapabilities->srsSupport << 4) |
-            (m_mldCapabilities->tidToLinkMappingSupport << 5) |
-            (m_mldCapabilities->freqSepForStrApMld << 7) | (m_mldCapabilities->aarSupport << 12);
-        start.WriteHtolsbU16(val);
-    }
-}
+NS_LOG_COMPONENT_DEFINE("MultiLinkElement");
 
-uint8_t
-CommonInfoBasicMle::Deserialize(Buffer::Iterator start, uint16_t presence)
-{
-    Buffer::Iterator i = start;
-
-    uint8_t length = i.ReadU8();
-    ReadFrom(i, m_mldMacAddress);
-    uint8_t count = 7;
-
-    if ((presence & 0x0001) != 0)
-    {
-        m_linkIdInfo = i.ReadU8() & 0x0f;
-        count++;
-    }
-    if ((presence & 0x0002) != 0)
-    {
-        m_bssParamsChangeCount = i.ReadU8();
-        count++;
-    }
-    if ((presence & 0x0004) != 0)
-    {
-        m_mediumSyncDelayInfo = MediumSyncDelayInfo();
-        m_mediumSyncDelayInfo->mediumSyncDuration = i.ReadU8();
-        uint8_t val = i.ReadU8();
-        m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold = val & 0x0f;
-        m_mediumSyncDelayInfo->mediumSyncMaxNTxops = (val >> 4) & 0x0f;
-        count += 2;
-    }
-    if ((presence & 0x0008) != 0)
-    {
-        m_emlCapabilities = EmlCapabilities();
-        uint16_t val = i.ReadLsbtohU16();
-        m_emlCapabilities->emlsrSupport = val & 0x0001;
-        m_emlCapabilities->emlsrPaddingDelay = (val >> 1) & 0x0007;
-        m_emlCapabilities->emlsrTransitionDelay = (val >> 4) & 0x0007;
-        m_emlCapabilities->emlmrSupport = (val >> 7) & 0x0001;
-        m_emlCapabilities->emlmrDelay = (val >> 8) & 0x0007;
-        m_emlCapabilities->transitionTimeout = (val >> 11) & 0x000f;
-        count += 2;
-    }
-    if ((presence & 0x0010) != 0)
-    {
-        m_mldCapabilities = MldCapabilities();
-        uint16_t val = i.ReadLsbtohU16();
-        m_mldCapabilities->maxNSimultaneousLinks = val & 0x000f;
-        m_mldCapabilities->srsSupport = (val >> 4) & 0x0001;
-        m_mldCapabilities->tidToLinkMappingSupport = (val >> 5) & 0x0003;
-        m_mldCapabilities->freqSepForStrApMld = (val >> 7) & 0x001f;
-        m_mldCapabilities->aarSupport = (val >> 12) & 0x0001;
-        count += 2;
-    }
-
-    NS_ABORT_MSG_IF(count != length,
-                    "Common Info Length (" << +length
-                                           << ") differs "
-                                              "from actual number of bytes read ("
-                                           << +count << ")");
-    return count;
-}
-
-uint8_t
-CommonInfoBasicMle::EncodeEmlsrPaddingDelay(Time delay)
-{
-    auto delayUs = delay.GetMicroSeconds();
-
-    if (delayUs == 0)
-    {
-        return 0;
-    }
-
-    for (uint8_t i = 1; i <= 4; i++)
-    {
-        if (1 << (i + 4) == delayUs)
-        {
-            return i;
-        }
-    }
-
-    NS_ABORT_MSG("Value not allowed (" << delay.As(Time::US) << ")");
-    return 0;
-}
-
-Time
-CommonInfoBasicMle::DecodeEmlsrPaddingDelay(uint8_t value)
-{
-    NS_ABORT_MSG_IF(value > 4, "Value not allowed (" << +value << ")");
-    if (value == 0)
-    {
-        return MicroSeconds(0);
-    }
-    return MicroSeconds(1 << (4 + value));
-}
-
-uint8_t
-CommonInfoBasicMle::EncodeEmlsrTransitionDelay(Time delay)
-{
-    auto delayUs = delay.GetMicroSeconds();
-
-    if (delayUs == 0)
-    {
-        return 0;
-    }
-
-    for (uint8_t i = 1; i <= 5; i++)
-    {
-        if (1 << (i + 3) == delayUs)
-        {
-            return i;
-        }
-    }
-
-    NS_ABORT_MSG("Value not allowed (" << delay.As(Time::US) << ")");
-    return 0;
-}
-
-Time
-CommonInfoBasicMle::DecodeEmlsrTransitionDelay(uint8_t value)
-{
-    NS_ABORT_MSG_IF(value > 5, "Value not allowed (" << +value << ")");
-    if (value == 0)
-    {
-        return MicroSeconds(0);
-    }
-    return MicroSeconds(1 << (3 + value));
-}
-
-void
-CommonInfoBasicMle::SetMediumSyncDelayTimer(Time delay)
-{
-    int64_t delayUs = delay.GetMicroSeconds();
-    NS_ABORT_MSG_IF(delayUs % 32 != 0, "Delay must be a multiple of 32 microseconds");
-    delayUs /= 32;
-
-    if (!m_mediumSyncDelayInfo.has_value())
-    {
-        m_mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
-    }
-    m_mediumSyncDelayInfo->mediumSyncDuration = (delayUs & 0xff);
-}
-
-Time
-CommonInfoBasicMle::GetMediumSyncDelayTimer() const
-{
-    NS_ASSERT(m_mediumSyncDelayInfo);
-    return MicroSeconds(m_mediumSyncDelayInfo->mediumSyncDuration * 32);
-}
-
-void
-CommonInfoBasicMle::SetMediumSyncOfdmEdThreshold(int8_t threshold)
-{
-    NS_ABORT_MSG_IF(threshold < -72 || threshold > -62, "Threshold may range from -72 to -62 dBm");
-    uint8_t value = 72 + threshold;
-
-    if (!m_mediumSyncDelayInfo.has_value())
-    {
-        m_mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
-    }
-    m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold = value;
-}
-
-int8_t
-CommonInfoBasicMle::GetMediumSyncOfdmEdThreshold() const
-{
-    NS_ASSERT(m_mediumSyncDelayInfo);
-    return (m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold) - 72;
-}
-
-void
-CommonInfoBasicMle::SetMediumSyncMaxNTxops(uint8_t nTxops)
-{
-    NS_ASSERT_MSG(nTxops < 16, "Value " << +nTxops << "cannot be encoded in 4 bits");
-
-    if (!m_mediumSyncDelayInfo.has_value())
-    {
-        m_mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
-    }
-
-    if (nTxops == 0)
-    {
-        // no limit on max number of TXOPs
-        m_mediumSyncDelayInfo->mediumSyncMaxNTxops = 15;
-        return;
-    }
-
-    m_mediumSyncDelayInfo->mediumSyncMaxNTxops = --nTxops;
-}
-
-std::optional<uint8_t>
-CommonInfoBasicMle::GetMediumSyncMaxNTxops() const
+namespace ns3
 {
-    NS_ASSERT(m_mediumSyncDelayInfo);
-    uint8_t nTxops = m_mediumSyncDelayInfo->mediumSyncMaxNTxops;
-    if (nTxops == 15)
-    {
-        return std::nullopt;
-    }
-    return nTxops + 1;
-}
 
-/**
- * MultiLinkElement
- */
 MultiLinkElement::MultiLinkElement(ContainingFrame frame)
     : m_containingFrame(frame),
       m_commonInfo(std::in_place_type<std::monostate>) // initialize as UNSET
@@ -326,6 +61,9 @@
     case BASIC_VARIANT:
         m_commonInfo = CommonInfoBasicMle();
         break;
+    case PROBE_REQUEST_VARIANT:
+        m_commonInfo = CommonInfoProbeReqMle();
+        break;
     default:
         NS_ABORT_MSG("Unsupported variant: " << +variant);
     }
@@ -493,6 +231,39 @@
     return MicroSeconds(1 << (6 + emlCapabilities->transitionTimeout));
 }
 
+void
+MultiLinkElement::SetApMldId(uint8_t id)
+{
+    const auto variant = GetVariant();
+    switch (variant)
+    {
+    case BASIC_VARIANT:
+        std::get<CommonInfoBasicMle>(m_commonInfo).m_apMldId = id;
+        return;
+    case PROBE_REQUEST_VARIANT:
+        std::get<CommonInfoProbeReqMle>(m_commonInfo).m_apMldId = id;
+        return;
+    default:
+        NS_ABORT_MSG("AP MLD ID field not present in input variant " << variant);
+    }
+}
+
+std::optional<uint8_t>
+MultiLinkElement::GetApMldId() const
+{
+    const auto variant = GetVariant();
+    switch (variant)
+    {
+    case BASIC_VARIANT:
+        return std::get<CommonInfoBasicMle>(m_commonInfo).m_apMldId;
+    case PROBE_REQUEST_VARIANT:
+        return std::get<CommonInfoProbeReqMle>(m_commonInfo).m_apMldId;
+    default:
+        NS_LOG_DEBUG("AP MLD ID field not present in input variant");
+    }
+    return std::nullopt;
+}
+
 MultiLinkElement::PerStaProfileSubelement::PerStaProfileSubelement(Variant variant)
     : m_variant(variant),
       m_staControl(0)
@@ -503,7 +274,8 @@
     const PerStaProfileSubelement& perStaProfile)
     : m_variant(perStaProfile.m_variant),
       m_staControl(perStaProfile.m_staControl),
-      m_staMacAddress(perStaProfile.m_staMacAddress)
+      m_staMacAddress(perStaProfile.m_staMacAddress),
+      m_bssParamsChgCnt(perStaProfile.m_bssParamsChgCnt)
 {
     // deep copy of the STA Profile field
     auto staProfileCopy = [&](auto&& frame) {
@@ -533,6 +305,7 @@
     m_variant = perStaProfile.m_variant;
     m_staControl = perStaProfile.m_staControl;
     m_staMacAddress = perStaProfile.m_staMacAddress;
+    m_bssParamsChgCnt = perStaProfile.m_bssParamsChgCnt;
 
     // deep copy of the STA Profile field
     auto staProfileCopy = [&](auto&& frame) {
@@ -599,6 +372,29 @@
 }
 
 void
+MultiLinkElement::PerStaProfileSubelement::SetBssParamsChgCnt(uint8_t count)
+{
+    NS_ABORT_MSG_IF(m_variant != BASIC_VARIANT,
+                    "Expected Basic Variant, variant:" << +static_cast<uint8_t>(m_variant));
+    m_bssParamsChgCnt = count;
+    m_staControl |= 0x0800;
+}
+
+bool
+MultiLinkElement::PerStaProfileSubelement::HasBssParamsChgCnt() const
+{
+    return (m_staControl & 0x0800) != 0;
+}
+
+uint8_t
+MultiLinkElement::PerStaProfileSubelement::GetBssParamsChgCnt() const
+{
+    NS_ASSERT_MSG(m_bssParamsChgCnt.has_value(), "No value set for m_bssParamsChgCnt");
+    NS_ASSERT_MSG(HasBssParamsChgCnt(), "BSS Parameters Change count bit not set");
+    return m_bssParamsChgCnt.value();
+}
+
+void
 MultiLinkElement::PerStaProfileSubelement::SetAssocRequest(
     const std::variant<MgtAssocRequestHeader, MgtReassocRequestHeader>& assoc)
 {
@@ -669,15 +465,49 @@
     return *std::get<std::unique_ptr<MgtAssocResponseHeader>>(m_staProfile);
 }
 
+void
+MultiLinkElement::PerStaProfileSubelement::SetProbeResponse(const MgtProbeResponseHeader& probeResp)
+{
+    m_staProfile = std::make_unique<MgtProbeResponseHeader>(probeResp);
+}
+
+void
+MultiLinkElement::PerStaProfileSubelement::SetProbeResponse(MgtProbeResponseHeader&& probeResp)
+{
+    m_staProfile = std::make_unique<MgtProbeResponseHeader>(std::move(probeResp));
+}
+
+bool
+MultiLinkElement::PerStaProfileSubelement::HasProbeResponse() const
+{
+    return std::holds_alternative<std::unique_ptr<MgtProbeResponseHeader>>(m_staProfile);
+}
+
+MgtProbeResponseHeader&
+MultiLinkElement::PerStaProfileSubelement::GetProbeResponse() const
+{
+    NS_ABORT_IF(!HasProbeResponse());
+    return *std::get<std::unique_ptr<MgtProbeResponseHeader>>(m_staProfile);
+}
+
 uint8_t
 MultiLinkElement::PerStaProfileSubelement::GetStaInfoLength() const
 {
+    if (m_variant == PROBE_REQUEST_VARIANT)
+    {
+        return 0; // IEEE 802.11be 6.0 Figure 9-1072s
+    }
+
     uint8_t ret = 1; // STA Info Length
 
     if (HasStaMacAddress())
     {
         ret += 6;
     }
+    if (HasBssParamsChgCnt())
+    {
+        ret += 1;
+    }
     // TODO add other subfields of the STA Info field
     return ret;
 }
@@ -721,6 +551,13 @@
 void
 MultiLinkElement::PerStaProfileSubelement::SerializeInformationField(Buffer::Iterator start) const
 {
+    if (m_variant == PROBE_REQUEST_VARIANT)
+    {
+        NS_ASSERT_MSG(IsCompleteProfileSet(), "Encoding of STA Profile not supported");
+        start.WriteHtolsbU16(m_staControl);
+        return;
+    }
+
     start.WriteHtolsbU16(m_staControl);
     start.WriteU8(GetStaInfoLength());
 
@@ -728,6 +565,10 @@
     {
         WriteTo(start, m_staMacAddress);
     }
+    if (HasBssParamsChgCnt())
+    {
+        start.WriteU8(GetBssParamsChgCnt());
+    }
     // TODO add other subfields of the STA Info field
     auto staProfileSerialize = [&](auto&& frame) {
         using T = std::decay_t<decltype(frame)>;
@@ -754,6 +595,11 @@
 MultiLinkElement::PerStaProfileSubelement::DeserializeInformationField(Buffer::Iterator start,
                                                                        uint16_t length)
 {
+    if (m_variant == PROBE_REQUEST_VARIANT)
+    {
+        return DeserProbeReqMlePerSta(start, length);
+    }
+
     Buffer::Iterator i = start;
 
     m_staControl = i.ReadLsbtohU16();
@@ -763,6 +609,10 @@
     {
         ReadFrom(i, m_staMacAddress);
     }
+    if (HasBssParamsChgCnt())
+    {
+        m_bssParamsChgCnt = i.ReadU8();
+    }
 
     // TODO add other subfields of the STA Info field
     uint16_t count = i.GetDistanceFrom(start);
@@ -790,6 +640,42 @@
     return count;
 }
 
+uint16_t
+MultiLinkElement::PerStaProfileSubelement::DeserProbeReqMlePerSta(ns3::Buffer::Iterator start,
+                                                                  uint16_t length)
+{
+    NS_ASSERT_MSG(m_variant == PROBE_REQUEST_VARIANT,
+                  "Invalid Multi-link Element variant = " << static_cast<uint8_t>(m_variant));
+    Buffer::Iterator i = start;
+    uint16_t count = 0;
+
+    m_staControl = i.ReadLsbtohU16();
+    count += 2;
+
+    NS_ASSERT_MSG(count <= length,
+                  "Incorrect decoded size count =" << count << ", length=" << length);
+    if (count == length)
+    {
+        return count;
+    }
+
+    // TODO: Support decoding of Partial Per-STA Profile
+    // IEEE 802.11be D5.0 9.4.2.312.3 Probe Request Multi-Link element
+    // If the Complete Profile Requested subfield is set to 0 and the STA Profile field
+    // is present in a Per-STA Profile subelement,
+    // the STA Profile field includes exactly one of the following:
+    // - one Request element (see 9.4.2.9 (Request element)), or
+    // — one Extended Request element (see 9.4.2.10 (Extended Request element)), or
+    // — one Request element and one Extended Request element
+    NS_LOG_DEBUG("Decoding of STA Profile in Per-STA Profile subelement not supported");
+    while (count < length)
+    {
+        i.ReadU8();
+        count++;
+    }
+    return count;
+}
+
 void
 MultiLinkElement::AddPerStaProfileSubelement()
 {
